#include <SPI.h>
#include <RH_RF95.h>
#include <DHT.h>
#include <Adafruit_Sensor.h>
#define DHTPIN 8
#define DHTTYPE DHT22
DHT dht = DHT(DHTPIN, DHTTYPE);

#define RESET 2
#define DIO0 3
#define NSS 4
#define FREQ 868.0 //433.0 //915.0

//construct the lora connection
RH_RF95 rf95(NSS, DIO0);

void setup()
{
  
  
  pinMode(RESET, OUTPUT);
  digitalWrite(RESET, HIGH);

  
  while(!Serial);
  Serial.begin(9600);
  delay(100);

  digitalWrite(RESET, LOW);
  delay(10);
  digitalWrite(RESET, HIGH);
  delay(10);
  
  
  while(!rf95.init()) {
  Serial.println("Initializing...");
  while (1);
  }
  Serial.println("Succeeded");


  if (!rf95.setFrequency(FREQ)) {
    Serial.println("Cant set frequency");
    while (1);
  }
  Serial.print("Set freq to: "); Serial.println(FREQ);
  //set the transmission power from 5 to 23
  rf95.setTxPower(5, false);

dht.begin();
}

void loop()
{
delay(10000);
char humidity[6] = "HHHHH";
char temperature[6] = "TTTTT";
float temperaturereading;
float humidityreading;
char* message;


humidityreading = dht.readHumidity();
temperaturereading = dht.readTemperature();

 dtostrf(humidityreading,4,2,humidity);
 dtostrf(temperaturereading,4,2,temperature);
 Serial.println(temperaturereading);
 Serial.println(humidityreading);
 message = malloc(strlen(temperature)+strlen(humidity)+1);
 strcpy(message,humidity);
 strcat(message,":");
 strcat(message,temperature);
 Serial.println(message);


  Serial.println("Sending to rf95_server");
  // Send a message to rf95_server
  uint8_t data[40] = {message};
  rf95.send((uint8_t *) message,40);
  
  rf95.waitPacketSent();
  // Now wait for a reply
  uint8_t buf[RH_RF95_MAX_MESSAGE_LEN];
  uint8_t len = sizeof(buf);

  if (rf95.waitAvailableTimeout(3000))
  { 
    // Should be a reply message for us now   
    if (rf95.recv(buf, &len))
   {
      Serial.print("got reply: ");
      Serial.println((char*)buf);
//      Serial.print("RSSI: ");
//      Serial.println(rf95.lastRssi(), DEC);    
    }
    else
    {
      Serial.println("recv failed");
    }
  }
  else
  {
    Serial.println("No reply, is rf95_server running?");
  }
  
 
}
